package com.engine.salary.mapper.datacollection;

import com.engine.salary.entity.datacollection.dto.VariableArchiveListDTO;
import com.engine.salary.entity.datacollection.param.VariableArchiveQueryParam;
import com.engine.salary.entity.datacollection.po.VariableArchivePO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * @author Harryxzy
 * @ClassName VariableArchiveMapper
 * @date 2024/08/07 9:18
 * @description 浮动薪酬档案
 */
public interface VariableArchiveMapper {
    /**
     * 查询所有记录
     *
     * @return 返回集合，没有返回空List
     */
    List<VariableArchivePO> listAll();

    /**
     * 条件查询
     *
     * @return 返回集合，没有返回空List
     */
    List<VariableArchivePO> listSome(VariableArchivePO variableArchive);


    /**
     * 根据主键查询
     *
     * @param id 主键
     * @return 返回记录，没有返回null
     */
    VariableArchivePO getById(Long id);

    /**
     * 新增，忽略null字段
     *
     * @param variableArchive 新增的记录
     * @return 返回影响行数
     */
    int insertIgnoreNull(VariableArchivePO variableArchive);

    /**
     * 修改，修改所有字段
     *
     * @param variableArchive 修改的记录
     * @return 返回影响行数
     */
    int update(VariableArchivePO variableArchive);

    /**
     * 修改，忽略null字段
     *
     * @param variableArchive 修改的记录
     * @return 返回影响行数
     */
    int updateIgnoreNull(VariableArchivePO variableArchive);

    /**
     * 删除记录
     *
     * @param variableArchive 待删除的记录
     * @return 返回影响行数
     */
    int delete(VariableArchivePO variableArchive);

    /**
     * 删除记录
     *
     * @param variableArchiveIds 待删除的记录id
     * @return 返回影响行数
     */
    int deleteByIds(@Param("ids")List<Long> variableArchiveIds);

    List<VariableArchiveListDTO> list(@Param("param")VariableArchiveQueryParam queryParam);
}
